UNIT GEgn;

INTERFACE

TYPE
  EGNString = STRING[10];
  TSEx      = (Male,Female,NoMather);
  TMinMax   = RECORD
        Min : Word;
        Max : Word;
      Value : Word;
  END;

FUNCTION CheckEGN           (EGN:EGNString):Boolean;
FUNCTION GenEGN             (Year,Month,Day:TMinMax; Sex:TSex):EGNString;
FUNCTION GenerateRandomEGN  : EGNString;

IMPLEMENTATION

CONST
  EGNTable : ARRAY[1..9] OF Byte = (2,4,8,5,10,9,7,3,6);

VAR
  CorectCheckSum : Byte;

 FUNCTION ValidDate(D,M,Y:Word): Boolean;
 BEGIN
  IF (D < 1) OR (D > 31) OR (M < 1) OR (M > 12)
    THEN ValidDate := False
    ELSE CASE M OF
           4,6,9,11: ValidDate := (D <= 30);
           2:        ValidDate := (D <= 28) OR ((D = 29) AND (Y <> 1900) AND (Y <> 0) AND (Y MOD 4 = 0));
          ELSE ValidDate := True;
         END;
 END;

 FUNCTION StrToInt(Str:STRING): Longint;
 VAR Code:Integer; Temp:Longint;
 BEGIN
   IF Length(Str) = 0
    THEN StrToInt := 0
    ELSE
     BEGIN
       Val(Str,Temp,Code);
       IF Code = 0
        THEN StrToInt := Temp
        ELSE StrToInt := 0;
     END;
 END;

 FUNCTION IntToStr(Number:Longint): STRING;
 VAR Temp:STRING;
 BEGIN
   Str(Number,Temp);
   IntToStr := Temp;
 END;




FUNCTION CheckEGN(EGN:EGNString):Boolean;
VAR I:Byte; Sum,Sum2:Real; Code:Byte; CheckSum:Byte; Junk:Integer;
BEGIN
  CheckEGN := False;
  Sum := 0;
  FOR I := 1 TO 9 DO
  BEGIN
    Code := StrToInt(EGN[I]) * EGNtable[I];
    Sum := Sum + Code;
  END;
  CheckSum := StrToInt(EGN[10]);
  CorectCheckSum := Trunc(Sum - (Int(Sum/11)*11));
  IF CheckSum = CorectCheckSum THEN CheckEGN := True;
END;


FUNCTION GenEGN(Year,Month,Day:TMinMax; Sex:TSex):EGNString;
LABEL Again;
VAR Unk,SexNum:Byte; EGN:EGNString; CheckSum:STRING[1];

  FUNCTION GetStr(V:Byte):STRING;
  BEGIN
    IF V <= 9
     THEN GetStr := '0' + IntToStr(V)
     ELSE GetStr := IntToStr(V);
  END;

BEGIN
 Again:
  REPEAT
    Year.Value  := Random(Year.Max  - Year.Min+1  ) + Year.Min;
    Month.Value := Random(Month.Max - Month.Min+1 ) + Month.Min;
    Day.Value   := Random(Day.Max   - Day.Min+1   ) + Day.Min;
  UNTIL ValidDate(Day.Value,Month.Value,Year.Value+1900);

  SexNum  := Random(7)+1;
  CASE Sex OF
    Male: IF Odd(SexNum)     THEN Inc(SexNum);
  Female: IF NOT Odd(SexNum) THEN Inc(SexNum);
  END;

  Unk     := Random(89)+10;
 {^^^^^^^^^^^^^^^^^^^^^^^^}
  EGN := GetStr(Year.Value)+
         GetStr(Month.Value)+
         GetStr(Day.Value)+
         GetStr(Unk)+
         IntToStr(SexNum)  +  '0';
  CheckEGN(EGN);
  Str(CorectCheckSum,CheckSum);
  EGN[10] := CheckSum[1];
  IF NOT CheckEGN(EGN) THEN GOTO Again;
  GenEGN := EGN;
END;


FUNCTION GenerateRandomEGN:EGNString;
VAR Y,M,D:TMinMax; S:TSex;
BEGIN
  Y.Min := 01;  Y.Max := 99;
  M.Min := 01;  M.Max := 12;
  D.Min := 01;  D.Max := 31;
  S := Nomather;
  GenerateRandomEGN := GenEGN(Y,M,D,S);
END;


END.